import { AfterViewInit } from "@angular/core";
import { UntypedFormControl } from "@angular/forms";
import { ArrayProperty } from "./model/arrayproperty";
import { FormProperty } from "./model/formproperty";
import { ObjectProperty } from "./model/objectproperty";
import { ISchema } from "./model/ISchema";
import * as i0 from "@angular/core";
export declare abstract class Widget<T extends FormProperty> {
    formProperty: T;
    control: UntypedFormControl;
    errorMessages: string[];
    id: string;
    name: string;
    schema: ISchema;
}
export declare class ControlWidget extends Widget<FormProperty> implements AfterViewInit {
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ControlWidget, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ControlWidget, never, never, {}, {}, never, never, false>;
}
export declare class ArrayLayoutWidget extends Widget<ArrayProperty> implements AfterViewInit {
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayLayoutWidget, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ArrayLayoutWidget, never, never, {}, {}, never, never, false>;
}
export declare class ObjectLayoutWidget extends Widget<ObjectProperty> implements AfterViewInit {
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectLayoutWidget, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ObjectLayoutWidget, never, never, {}, {}, never, never, false>;
}
